import os
import re 
import time
import socket

class Gain_Param():
    def GET_IP(self):
        #会存在异常  卡死   谨慎获取  
        #There will be exceptions, get stuck, get it carefully
        #Threading is better
        s=socket.socket(socket.AF_INET,socket.SOCK_DGRAM)
        s.connect_ex(('8.8.8.8',80))
        ip=s.getsockname()[0]
        s.close()
        return ip

    def GET_Temp(self):
        with open('/sys/class/thermal/thermal_zone0/temp', 'rt') as f:
            temp = int(f.read()) // 1000
        #print(temp)
        return temp

    def net_speed(self,interface, is_download):
        # Get the corresponding value   获取对应值
        which_num = 0 if is_download else 8

        # Read the file  读取文件
        with open('/proc/net/dev') as f:
            lines = f.readlines()
        # Get result value 获取结果值       
        for line in lines:
            if line.rstrip().split(':')[0].strip() == interface:
                return line.rstrip().split(':')[1].split()[which_num]

    def RX_speed(self,network):
        interface = network
        is_upload = True#False 
        get_time = 0.1
        # Computation part 计算部分
        begin = int(self.net_speed(interface, is_upload))
        time.sleep(get_time)
        end = int(self.net_speed(interface, is_upload))
        RX = (end-begin) /get_time/1024
        if RX < 1024:
            return (str(round(RX,2)) + "K/s").encode() #k
        else:
            return (str(round(RX / 1024,2)) + "M/s").encode() #M
        
        
    def TX_speed(self,network):
        interface = network
        is_upload = False 
        get_time = 0.1
        # Computation part 计算部分
        begin = int(self.net_speed(interface, is_upload))
        time.sleep(get_time)
        end = int(self.net_speed(interface, is_upload))
        TX = ((end-begin) /get_time/1024)
        if TX < 1024:
            return (str(round(TX,2)) + "K/s").encode() #k
        else:
            return (str(round(TX / 1024,2)) + "M/s").encode() #M
        # return  round(((end-begin) /get_time/1024),2)
    
    def GET_CPU_Used(self):
        CPU_usage = os.popen('top -bi -n 2 -d 0.02').read().split('\n\n\n')[0].split('\n')[2]
        CPU_usage = re.sub('[a-zA-z%(): ]','',CPU_usage)
        CPU_usage= CPU_usage.split(',')

        return int(100 - eval(CPU_usage[3]))

    def GET_Memory_Percentage(self):
        tot_m, used_m, free_m = map(int, os.popen('free -t -m').readlines()[-1].split()[1:])

        return int(100 - free_m/tot_m*100)

    def GET_System_Disk_Used(self):
        x = os.popen('df -h /')
        i2 = 0
        while 1:
            i2 = i2 + 1
            line = x.readline()
            if i2==2:
                Capacity_usage = line.split()[4] # Memory usage (%)   使用内存（百分值）
                Hard_capacity = int(re.sub('[%]','',Capacity_usage))
                break
        return Hard_capacity
                  
