#!/usr/bin/python
# -*- coding:utf-8 -*-
from sys import *  
from os import *  
from ctypes import *  

libdir = path.join(path.dirname(path.dirname(path.realpath(__file__))), 'lib')
if path.exists(libdir):
    path.append(libdir)
    
from lib.Monitor import *

System_path ='/home/pi'# Set the path to store the files ôļ·
# /home/pi needs to be changed to the actual storage path of the current system 
# Example: stored in /home/pi/Desktop, this time need to be changed to '/home/pi/Desktop'
# /home/pi Ҫĳɵǰϵͳʵʴ·
# :/home/pi/Desktop,˴Ҫĳ'/home/pi/Desktop'

# Select the function to execute
# ѡִеĹ
Monitor_Theme   = False 
Monitor_Mp4     = False
Monitor_Png     = False
Monitor_all     = False
Monitor_Delete_Files = False

if(len(argv) == 1 ):
    Monitor_Theme = True
elif (len(argv) == 2):
    ar =  argv[1]
    if  (ar == "T" or ar =="t" or ar == "THEME" or ar == "theme"):
        Monitor_Theme = True
    elif(ar == "M" or ar =="m" or ar == "MP4" or ar == "mp4"):
        Monitor_Mp4 = True
    elif(ar == "P" or ar =="p" or ar == "PNG" or ar == "png"):
        Monitor_Png = True
    elif(ar == "A" or ar =="a" or ar == "ALL" or ar == "all"):
        Monitor_all = True
    elif(ar == "D" or ar =="d" or ar == "DEL" or ar == "del"):
        Monitor_Delete_Files = True
    else :
        print ("There is a problem with the entered parameters")
        print ("example: python main.py t")
        exit()
else :
    print ("There is a problem with the entered parameters")
    print ("example: python main.py t")
    exit()

NETWORK = 'eth0' # Set up speed test network card ò

GET_SYSTEM_DATA = True # Whether to obtain system data Ƿȡϵͳ

ROTATE    = 1 #Set flip 1: flip 180 degrees 0: no flip ÷ת 1ת180 0ת
BACKLIGHT = 255 #Set the brightness, 0 is the darkest, 255 is the brightest ȣ0Ϊ255Ϊ


# The language setting here needs to be consistent with the one used by the 
# host computer when creating the theme, otherwise an exception will be displayed.
# Ҫλʱʹõһ£ʾ쳣
Monitor_Is12hour = 0        # 0: 24-hour format 1: 12-hour format 024Сʱ 112Сʱ
Monitor_Language = 1        # 0: Chinese 1: English 0 1Ӣ
Monitor_WeatherTempUnit = 0 # 0: Celsius 1: Fahrenheit 0϶ 1϶

Project_path = System_path.encode() + b"/2.1inch_USB_Monitor_RPi/Demo" # The absolute address where the file is stored ļľԵַ

File_num = 3 # The number of cycles displayed ѭʾ

File_path = [[] for _ in range(File_num)] # Create a variable that holds the file path ļ·ı
if Monitor_Theme:
    File_path[0] = b"/theme/480x480/astronaut.Theme" # file path ļ
    File_path[1] = b"/theme/480x480/pointer table.Theme"
    File_path[2] = b"/theme/480x480/water.Theme"
    #The interval of circular display is different for different file sizes, and the time setting is also changed accordingly for better effect.
    cycle_time = 12 # ѭʾļͬļСͬʱҲӦĸı䣬Ч
elif Monitor_Mp4:
    File_path[0] = b"/video/custom/spaceman.mp4" #file path ļ
    File_path[1] = b"/video/custom/Video 14.mp4"
    File_path[2] = b"/video/custom/water.mp4"
    # The interval of circular display is different for different file sizes, and the time setting is also changed accordingly for better effect.
    cycle_time = 5 #ѭʾļͬļСͬʱҲӦĸı䣬Ч
elif Monitor_Png:
    File_path[0] = b"/image/custom/astronaut.png" #file path ļ
    File_path[1] = b"/image/custom/pointer table.png"
    File_path[2] = b"/image/custom/water.png"
    # The interval of circular display is different for different file sizes, and the time setting is also changed accordingly for better effect.
    cycle_time = 5 #ѭʾļͬļСͬʱҲӦĸı䣬Ч
elif Monitor_all:
    File_num = 9 # The number of cycles displayed ѭʾ
    File_path = [[] for _ in range(File_num)] #ļ·ı
    File_path[0] = b"/theme/480x480/astronaut.Theme" #file path ļ
    File_path[1] = b"/theme/480x480/pointer table.Theme"
    File_path[2] = b"/theme/480x480/water.Theme"
    File_path[3] = b"/video/custom/spaceman.mp4" 
    File_path[4] = b"/video/custom/Video 14.mp4"
    File_path[5] = b"/video/custom/water.mp4"
    File_path[6] = b"/image/custom/astronaut.png" 
    File_path[7] = b"/image/custom/pointer table.png"
    File_path[8] = b"/image/custom/water.png"
    # The interval of circular display is different for different file sizes, and the time setting is also changed accordingly for better effect.
    cycle_time = 12 #ѭʾļͬļСͬʱҲӦĸı䣬Ч
elif Monitor_Delete_Files:
    GET_SYSTEM_DATA = False
    # pass
else:
    print("There is no file set to be displayed")

if __name__ == "__main__":
    mon = Monitor(System_path,NETWORK,GET_SYSTEM_DATA,Monitor_Is12hour,Monitor_Language,Monitor_WeatherTempUnit)
    if Monitor_Delete_Files == False:
        files = (c_char_p * File_num)()  # Number of file pointers to create ļָ
        for i in range(File_num):
            files[i] = Project_path + File_path[i]   
        
        mon.SetRootDir(Project_path)  
        mon.Download(cast(addressof(files), POINTER(c_char_p)),File_num,cycle_time,ROTATE,BACKLIGHT)
    else:
        mon.Delete()



